/**
 * The purpose of this class is to allow the BinaryLexer to be called as the BulkExtractor.
 * A future BulkExtractor might do more.
 */

import java.io.*;
import java.util.*;	// map, set

class BulkExtractor {
    public static void usage(){
	System.out.println("usage: bulk_extractor [options] filename");
	System.out.println("    -x suppressfile  - Do not print email addresses in suppressfile");
	System.exit(0);
    }

    public static void main(String [] argv) {
	gnu.getopt.Getopt g = new gnu.getopt.Getopt("bulk_extractor", argv, "x:");
	int c;
	String suppressFile=null;
	MapCollection mc = new MapCollection();
	while ((c = g.getopt()) != -1) {
	    switch(c) {
	    case 'x':
		mc.read_suppress_set_from_file(g.getOptarg());
		break;
		//
	    case 'h':
	    case '?':
		break; // getopt() already printed an error
		//
	    default:
		System.out.print("getopt() returned " + c + "\n");
	    }
	}

	if(g.getOptind() == argv.length) usage();
	for (int i = g.getOptind(); i < argv.length; i++) {
	    try {
		String fname = argv[i];
		System.out.println("Starting input file ["+argv[i]+"]");
		System.out.println("Time: " + new Date());
		BinaryLexer l = new BinaryLexer(new StraightStreamReader(new FileInputStream(fname)));
		l.mc = mc;
		do {
		    l.yylex();
		} while (!l.at_eof());
		l.mc.print_report();
	    }
	    catch (Exception e) {
		e.printStackTrace(System.out);
		System.exit(1);
	    }
	}
    }
}
