    /**
     * The TokenCounter class is used for the histogram report.
     * It keeps track of how many times each string was found.
     */

    public class TokenCounter implements Comparable<TokenCounter> {
        public String text;
        public int count = 0;
  
        TokenCounter (String match_text, int match_count) {
            text = match_text;
            count = match_count;
        }

        public String toString() {
            return text + ": " + count;
        }

        public int compareTo(TokenCounter token) {
            if (this.count > token.count) return -1;
            else if (this.count < token.count) return 1;
            else return this.text.compareTo(token.text); // count matches so return string comparison
        }
    }
