#include <iostream>
#include <map>
#include <vector>

using namespace std;

/* The ReportElement is used for creating the report of histogram frequencies.
 */
class ReportElement {
    public:
    ReportElement(string aValue,int aCount):value(aValue),count(aCount){ }
    string value;
    int    count;
    static bool compare(const ReportElement &e1,const ReportElement &e2) {
	if (e1.count > e2.count) return true;
	if (e1.count < e2.count) return false;
	return e1.value < e2.value;
    }
};
    
class FrequencyReport : public vector<ReportElement> {
public:
    friend ostream & operator <<(ostream &os,const FrequencyReport &rep);
};

class histogram {
public:

    map<string,int> db;
    void add(const string &key){
	db[key] = db[key]+1;
    }
    void addIfNotPresent(const string &key){
	if(db[key]==0) db[key] = 1;
    }
    FrequencyReport *makeReport();	// return a report with all of them
    FrequencyReport *makeReport(int topN);
};

    


